#version 150

uniform sampler2D DiffuseSampler;
uniform sampler2D BloomSampler;

uniform vec2 InSize;
uniform float BloomIntensity;

in vec2 texCoord;
in vec2 texelSize;

out vec4 fragColor;

void main() 
{
    vec3 color = texture(DiffuseSampler, texCoord).rgb;
    float colorIntensity = length(color) * 0.8;

    vec3 bloom = texture(BloomSampler, texCoord).rgb * BloomIntensity;

    fragColor = vec4(color + (bloom * pow(0.08, colorIntensity)), 1.0);
}
