#version 150

uniform sampler2D DiffuseSampler;

uniform vec2 InSize;
uniform float BrightnessThreshold;
uniform float IntensityScale;
uniform float IntensityBias;

in vec2 texCoord;

out vec4 fragColor;

vec3 rgbChannelWeights = vec3(0.2126, 0.7152, 0.0722);

void main() 
{
    vec3 color = texture(DiffuseSampler, texCoord).rgb;
    float brightness = dot(color, rgbChannelWeights);

    float intensity = max(0.0, pow((brightness - IntensityBias) / BrightnessThreshold, IntensityScale));
    fragColor = vec4(color * (brightness >= BrightnessThreshold ? min(1.0, intensity) : 0.0), 1.0);
}
